
#include <signal.h> //per sigaction,
#include <sys/types.h> //per la fork, open
#include <sys/stat.h>  //per la  open
#include <fcntl.h> //per la open
#include <unistd.h>   //per la ttyname, pause
#include <stdio.h>   // per la scanf 
#include "sysmacro.h"  //macro di utilit
#include "salvo_utility.h" //utility da me definite
#include <string.h>  //per la strcpy,


#define LIM  5

int fd,f,letti, cont = 0, scelta = 0, flag= 1, terminale,c,comunicazione = 1;
message2 m2; 
database bd;
char state;
char mypipe[DIM],list[MASX]; 
void gestore1(int);
void gestoreInt(int);
void gestore2(int);
void gestoreTerm(int);
void invia1( int, int, int, char[], char);
void inviaSMS(int, int, int, int, char[],char[]);
void chiamata(int, int, int, int, char[] );
void listRequest(int, int, int, char[]);


int main()
     
{
  
  int numero,ok=1, ct=0, fdListpipe;
  char ssm[MAXS] ,appoggio[MAXS] ,  risposta[2]; 
  
  struct sigaction azione1, azione2, azioneInt, azioneTerm;
  sprintf(mypipe, "/tmp/%d.pipe", getpid());   //nome del mio pipe
  //----------------------------------------
  //segnale SIGUSR1
  IFERROR(sigaction(SIGUSR1,NULL,&azione1),"Errore nella sigaction");
  /* azione1 contiene il gestore di default per SIGUSR1 */
  
  azione1.sa_handler=gestore1;
  /* modifico la funzione per il gestore del segnale */
  
  IFERROR(sigaction(SIGUSR1,&azione1,NULL),"Errore nella sigaction");
  /* installo il nuovo gestore */
  
  //-----------------------------------------  
  //segnale SIGUSR2
  IFERROR(sigaction(SIGUSR2,NULL,&azione2),"Errore nella sigaction");
  azione2.sa_handler=gestore2; 
  IFERROR(sigaction(SIGUSR2,&azione2,NULL),"Errore nella sigaction");
  
  //----------------------------------------------------
  //segnale SIGINT
  IFERROR(sigaction(SIGINT,NULL,&azioneInt),"Errore nella sigaction");
  azioneInt.sa_handler=gestoreInt;
  IFERROR(sigaction(SIGINT,&azioneInt,NULL),"Errore nella sigaction");
  
  //------------------------------------------------------------------
  //segnale SIGTERM
  IFERROR(sigaction(SIGTERM,NULL,&azioneTerm),"Errore nella sigaction");
  azioneTerm.sa_handler=gestoreTerm;
  IFERROR(sigaction(SIGTERM,&azioneTerm,NULL),"Errore nella sigaction");
  
  //------------------------------------------------------------------

  //inizio gestione Pipe

  while( ((fd = open(PIPE, O_WRONLY)) == -1) && (cont < LIM) )   //se il pipe non esiste allora ciclo aspettando che venga creato
    { 
      printf("%d) pid: %d tty: %s\n",(cont+1),getpid(),ttyname(1));
      sleep(1);     
      cont+=1;
      
    }//end while( ((fd = open(PIPE, O_WRONLY)) == -1) && (cont < LIM) ) 
  
  if (cont >=LIM) 
    {
      printf("Il pipe di comunicazione non c',  riprova + tardi \n");
      exit (-1);
    }//end if(cont >=LIM) 
  
  state = 'R';  // stato cell Ready
  invia1(fd, 1, getpid(), ttyname(1), state);
  
  //schermata utente
  do
    { 
      scelta = 0;
      printf("|---------------------------------------------------|\n");
      printf("| Ciao sono il tuo cellulare i miei servizi sono:   |\n");
      printf("|   ................................................|\n");
      printf("|  1) Invio SMS ....................................|\n");
      printf("|  2) Telefonate verso altri cellulari .............|\n");
      printf("|  3) Listare i telefoni disponibili ...............|\n");
      printf("|  4) Riproponi Menu................................|\n");
      printf("|  5) Uscita .......................................|\n");
      printf("|---------------------------------------------------|\n");
      printf("  Ti ricordo che sei %s  e il tuo tty : %s     \n",trasforma(state),ttyname(1) );
      printf("  E che il tuo numero di cellulare : %d        \n",getpid());
      printf(" \nScegli il servizio (digita il numero posto accanto):");
      scanf("%d", &scelta);
      
      switch(scelta)
	{
	case 1: 
	  {   // g e s t i o n e   s m s 
	    //qui vorrei disabilitare il gestore di SIGUSR1 e di SIGUSR2 inviare un messaggio di cambio di stato in 'O'perch non voglio che intanto che scrivo il messaggio qualcuno rompa 
	    state = 'O';
	    invia1(fd, 1, getpid(), ttyname(1), state);

	    printf("Digita numero da chiamare: ");
	    
	    scanf("%d", &numero);
	    if(numero == getpid())
	      {
		printf("Ma cosa fai vorresti inviare un SMS a te stesso?\nSai cosa  un cellulare?\n Questa richiesta non pu essere soddisfatta\n");
		invia1(fd, 1, getpid(), ttyname(1), 'R');
		break;
	      }
	   
	    printf("Hai inserito \"%d\"\n", numero);
	    printf("Scrivi SMS (max %d caratteri): ", MAXS);
	    ct = 0;
	    while(ok)
	      { 
		c= getchar();
		appoggio[ct] = (char) c;
		ct ++;
		if(c =='\n' && ct >1)  ok = 0;		
	      } // end  while(ok)
	    appoggio[ct-1] ='\0'; 
	    
	    strncpy(ssm, appoggio, ct);
	    printf("(caratteri usati: %d) Hai scritto: %s\n",ct-2,ssm);
	    ok=1;
	    
	    if (ct-2> MAXS)
	      {
		printf("Hai inserito %d caratteri il messaggio non verr inoltrato,quindi dovrai rifare tutto da capo\n", ct-2);
		break;
	      } //end  if (ct> MAXS)
	    
	    printf("Posso inviare? (\"si\" per confermare / \"no\" per annullare tutto):");
	    scanf("%s", risposta);
	    
	    if(strncmp(risposta , "si",2))      // if(risposta != "si") 
	      { 
		ok = 1;
		break;
	      }
	    strncpy(appoggio,"\0",sizeof(appoggio));
	  
	    inviaSMS(fd, (scelta+1), getpid(), numero, ttyname(1), ssm );
	    strncpy(ssm,"\0",sizeof(ssm));
	    //qui voglio ritornare a essere 'R'e a essere disponibile ai segnali
	    state = 'R';
	    invia1(fd, 1, getpid(), ttyname(1), state);
	    ct =0;
	    
	    break;
	  } //end case 1
	  
	case 2: 
	  {           //g e s t i o n e   c h i a m a t a   a   c e l l u l a r e 
	  
	    
	    state = 'O';
	    invia1(fd, 1, getpid(), ttyname(1), state);
	    
	    printf("Digita numero da chiamare: ");
	    scanf("%d", &numero);
	    
	    if(numero == getpid())
	      {
		printf("Ma cosa fai vorresti chiamare a te stesso? Sai cosa  un cellulare?\n Questa richiesta non pu essere soddisfatta\n");
		state = 'R';
		invia1(fd, 1, getpid(), ttyname(1), state);
		break;
	      }
	    printf("Hai inserito \"%d\"\n", numero);
	    printf("In attesa di risposta\n");
	    chiamata(fd, (scelta+1), getpid(), numero, ttyname(1));
	    pause();
	    state = 'R';
	    invia1(fd, 1, getpid(), ttyname(1), state);
	    break;
	  } //end case 2
	case 3:       //p e r   o t t e n e r e   l a   l i s t a    d e i    c e l l u l a r i 
	  {
	    listRequest( fd, (scelta+1), getpid(), ttyname(1));
	    
	    printf("Ho inoltrato la richiesta della lista\n");
	    sleep(1);
	    //    printf("|Num:|   tty:  |Stato: (R =libero, S= Spento, O= Occupato)\n"); 
	    
	    IFERROR( fdListpipe = open(mypipe, O_RDONLY), "Nell'apertura del pipe per ricevere la lista"); //apertura pipe
	    
	    while((letti= read(fdListpipe,&bd,(sizeof(database))))>0)
	      {
		if(bd.state == 'R')
		  printf("Numero disponibile: %d|\n", bd.number );
		else if(bd.state == 'O')
		  printf("Numero occupato:    %d|\n", bd.number );
		  
	      }//end while((letti= read(fdListpipe,&bd,(sizeof(database))))>0)
	    IFERROR(close( fdListpipe), "Nella chiusura del pipe personale per leggere la lista");   //Chiusura Pipe
	  
	    break; 
	  }
	  
	case 4:   //Riproponi menu
	  {
	    state = 'R';
	    invia1(fd, 1, getpid(), ttyname(1), state);
	    break;
	  }
	  
	case 5:    //p e r   c h i u d e r e   i l   c e l l u l a r e
	  { 
	    state = 'S';
	    invia1(fd, 1, getpid(), ttyname(1), state);
	    break;
	  } //end case 4
	default: 
	  {
	    if(flag) 
	      printf("\n\nMa sai leggere? Comprati gli occhiali se non ci vedi!!\n\n");  
	  } //end default
      	}//end switch
      state = 'R';
      // scelta = 0;
    }//end do-while
  while(scelta != 5);   
  return (0);
}//end main

//----------------   funzioni locali per inviare i vari tipi di messaggi ------------------

void invia1( int fdi, int typ, int myNum, char mytty[MA], char stat)
{  
  strcpy( m2.mytty, mytty);
  m2.type = typ;   
  m2.myNumber = myNum;
  m2.u.state= stat;
 
  write(fdi,&m2, sizeof(m2));
}

void inviaSMS(int fdi, int typ,int myNum, int dest, char mytty[MA],char mess[MAXS] )
{
  
  m2.type = typ;   
  m2.myNumber = myNum;
  strcpy( m2.mytty, mytty);
  m2.u.sm.called= dest;
  strcpy( m2.u.sm.mess, mess);
  write(fdi,&m2, sizeof(m2));
}

void chiamata(int fdi, int typ, int myNum, int dest, char mytty[MA])
{
 
  m2.type = typ;   
  m2.myNumber= myNum;
  m2.u.called= dest;
  strcpy( m2.mytty, mytty);
  write(fdi,&m2, sizeof(m2));  
}

void listRequest( int fdi, int typ, int myNum, char mytty[MA])
{
  m2.myNumber = myNum;
  m2.type = typ;   
  strcpy( m2.mytty, mytty);
  write(fdi,&m2, sizeof(m2));  
}

//--------------------------------------  Gestori segnali -------------------------------------------



void gestore1(int s)    //P e r   l e   c h i a m a t e 
{
  flag = 0;  //per evitare che mi scriva la frase finale ("ma sai leggere..." );
 
  sleep(1);
  IFERROR( f = open(mypipe, O_RDONLY), "Nell'apertura del pipe per ricevere il tty"); //apertura pipe
  
  while((letti= read(f,&bd,(sizeof(database))))>0)
    {
      if(bd.tty)
	printf("\nSei in comunicazione con %d\n", bd.number);
      
    }
  IFERROR(close(f), "Nella chiusura del pipe personale");   //Chiusura Pipe 
  IFERROR(terminale = open(bd.tty, O_WRONLY), "Nell'apertura del terminale ");
  comunicazione=0;
  state='O';
  invia1(fd, 1, getpid(), ttyname(1), state);
  (char) c= getchar();
  while (comunicazione==0) 
    {
      IFERROR(write(terminale, &c ,(sizeof(char)) ), "In scrittura su tty"); 
      (char) c= getchar();
    } 
  IFERROR(close(terminale), "Nella chiusura del terminale");   //Chiusura Pipe 

} //end gestore

void gestore2(int s)   //per gli SMS
{
  
  flag = 0; //per evitare che mi scriva la frase finale ("ma sai leggere..." );
  sleep(1);
  IFERROR( f = open(mypipe, O_RDONLY), "Nell'apertura del pipe per ricevere l'SMS"); //apertura pipe
  while((letti= read(f,list,MASX*(sizeof(char))))>0)
    {
      if(list)
	printf("%s\n", list);
    }//end  while((letti= read(f,list,MASX*(sizeof(char))))>0)
  
  IFERROR(close(f), "Nella chiusura del pipe personale per leggere l'SMS");   //Chiusura Pipe 
 
} //end gestore SMS

void gestoreTerm(int s)   //per la terminazione della comunicazione
{
  
  if(state == 'R')  
    flag =0;
    printf("\nLa comunicazione non  avvenuta o non pu avvenire\n");
  
  if (state == 'O') 
    { 
      if(comunicazione ==0)
	printf("Sei stato interrotto da %d\n",bd.number);
      //  else
      //	printf("La comunicazione  stata interrotta o non ha avuto successo\n");
      state = 'R';
      invia1(fd, 1, getpid(), ttyname(1), state);
    }
  
  comunicazione = 1;
} //end gestore

void gestoreInt(int s)
{
  
  if(state == 'R') 
    { //se si pigia CTRL+C intanto che c' il menu principale
      state = 'S';
      invia1(fd, 1, getpid(), ttyname(1), state);
      
      exit(0);
    }
  
  if (comunicazione==0)   //cio se sei in comunicazione con un altro utente
    {
      
      kill(bd.number, SIGTERM);//deve inviare un sigterm al processo con il quale sto comunicando
      printf("Hai interrotto la comunicazione con %d\n",bd.number);
      //devo chiudere il pipe mio
      state='R'; 
      invia1(fd, 1, getpid(), ttyname(1), state);
    }
  comunicazione=1;
  
} //end gestore
