#define MASX 165
#define MAXS 150
#define MA 12
#define MOD 101
#define DIM 40
#define PIPE "/tmp/FREETEL.pipe"

int ispipe(const char *filename)
{
  struct stat info;
  return (stat(filename, &info) != -1) && S_ISFIFO(info.st_mode);
}  //end ispipe

int isfile(const char *filename)
{
  struct stat info;
  return (stat(filename, &info) != -1) && S_ISREG(info.st_mode);
}  //end ispipe


// ---------------------------Strutture per gestire i messaggi da cellulare a Gestore

typedef union  
{
  char state;
  int called;
  struct  
  {
    int  called;
    char mess[MAXS];
  }sm;
  
}uni; 



typedef struct 
{
  int myNumber; 
  int type;
  char mytty[MA];
  uni u;
}message2;


typedef struct 
{
  int number;
  char tty[MA];
  char state;
} database;
// -----------------------end-Strutture per gestire i messaggi da cellulare a Gestore

char * trasforma( char p)
     
{  switch (p) 
  {
  case 'R': return "Ready"; 
  case 'O': return "Occupato";
  case 'S': return "Spento";
  default: return "Errore di trasmissione";
  } 
}
